/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */

#ifndef _PDU_SESSION_RESOURCE_HANDOVER_LIST_H_
#define _PDU_SESSION_RESOURCE_HANDOVER_LIST_H_

#include "PDUSessionResourceHandoverItem.hpp"
#include "vector"

extern "C" {
#include "Ngap_PDUSessionResourceHandoverList.h"
}

namespace ngap {

class PDUSessionResourceHandoverList {
 public:
  PDUSessionResourceHandoverList();
  virtual ~PDUSessionResourceHandoverList();

  void setPDUSessionResourceHandoverList(
      const std::vector<PDUSessionResourceHandoverItem>& list);
  void getPDUSessionResourceHandoverList(
      std::vector<PDUSessionResourceHandoverItem>& list);

  bool encode(
      Ngap_PDUSessionResourceHandoverList_t& pduSessionResourceHandoverList);
  bool decode(const Ngap_PDUSessionResourceHandoverList_t&
                  pduSessionResourceHandoverList);

 private:
  std::vector<PDUSessionResourceHandoverItem> handoverItemList;
};

}  // namespace ngap

#endif
