/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */
/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "Nssai.h"

namespace oai {
namespace amf {
namespace model {

Nssai::Nssai() {
  m_SupportedFeatures      = "";
  m_SupportedFeaturesIsSet = false;
  m_SingleNssaisIsSet      = false;
}

Nssai::~Nssai() {}

void Nssai::validate() {
  // TODO: implement validation
}

void to_json(nlohmann::json& j, const Nssai& o) {
  j = nlohmann::json();
  if (o.supportedFeaturesIsSet())
    j["supportedFeatures"] = o.m_SupportedFeatures;
  j["defaultSingleNssais"] = o.m_DefaultSingleNssais;
  if (o.singleNssaisIsSet()) j["singleNssais"] = o.m_SingleNssais;
}

void from_json(const nlohmann::json& j, Nssai& o) {
  if (j.find("supportedFeatures") != j.end()) {
    j.at("supportedFeatures").get_to(o.m_SupportedFeatures);
    o.m_SupportedFeaturesIsSet = true;
  }
  j.at("defaultSingleNssais").get_to(o.m_DefaultSingleNssais);
  if (j.find("singleNssais") != j.end()) {
    j.at("singleNssais").get_to(o.m_SingleNssais);
    o.m_SingleNssaisIsSet = true;
  }
}

std::string Nssai::getSupportedFeatures() const {
  return m_SupportedFeatures;
}
void Nssai::setSupportedFeatures(std::string const& value) {
  m_SupportedFeatures      = value;
  m_SupportedFeaturesIsSet = true;
}
bool Nssai::supportedFeaturesIsSet() const {
  return m_SupportedFeaturesIsSet;
}
void Nssai::unsetSupportedFeatures() {
  m_SupportedFeaturesIsSet = false;
}
std::vector<Snssai>& Nssai::getDefaultSingleNssais() {
  return m_DefaultSingleNssais;
}
void Nssai::setDefaultSingleNssais(std::vector<Snssai>& snssais) {
  m_DefaultSingleNssais = snssais;
}
std::vector<Snssai>& Nssai::getSingleNssais() {
  return m_SingleNssais;
}
bool Nssai::singleNssaisIsSet() const {
  return m_SingleNssaisIsSet;
}
void Nssai::unsetSingleNssais() {
  m_SingleNssaisIsSet = false;
}

}  // namespace model
}  // namespace amf
}  // namespace oai
